﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Configuration;

/*============================================================================
  File:     Form1.cs
 
  Summary:  This program illustrates that, as far as a client application
	    is concerned, reading a filestream-enabled column is exectly
	    the same of reading a varbinary(max) or image column.

  Date:     August 2008

  SQL Server Version: 10.0.1600.22 (RTM)
------------------------------------------------------------------------------
  Written by Bob Beauchemin, SQLskills.com

  For more scripts and sample code, check out http://www.SQLskills.com

  This script is intended only as a supplement to SQL Server Jumpstart program.
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

namespace FilestreamForms
{
    public partial class Form1 : Form
    {
        BindingSource bindingSource1 = new BindingSource();
        BindingSource bindingSource2 = new BindingSource();
        string connString = ConfigurationManager.ConnectionStrings["Northwind"].ConnectionString;

        public Form1()
        {
            InitializeComponent();

            button1.Click += new EventHandler(button1_Click);
            button2.Click += new EventHandler(button1_Click); 

        }

        private void button1_Click(object sender, EventArgs e)
        {
            string tableName;

            if (((Button)sender).Name == "button1")
                tableName = "Employees";
            else
                tableName = "Employees2";

            label1.Text = tableName; 

            SqlDataAdapter da1 = new SqlDataAdapter(
                string.Format("select employeeid, firstname, lastname, photo from {0}", tableName),
                connString
                );

            dataGridView1.DataSource = null;
            dataGridView1.Refresh();
            System.Threading.Thread.Sleep(100);
  

            dataGridView1.DataSource = bindingSource1;
            // Populate a new data table and bind it to the BindingSource.
            DataTable table = new DataTable();
            da1.Fill(table);
            bindingSource1.DataSource = table;

            // Resize the DataGridView columns to fit the newly loaded content.
            dataGridView1.AutoResizeColumns(
                DataGridViewAutoSizeColumnsMode.AllCellsExceptHeader);
            dataGridView1.AutoResizeRows(
                DataGridViewAutoSizeRowsMode.AllCellsExceptHeaders);
        }

    }
}
