
/*
declare @tab varchar(max)
declare @i int, @count int = 1
set @i = 30000

set @tab='create table maxcolumns (id int primary key '
while @count <= @i
begin
  select  @tab=@tab+',[col'+ cast(@count as varchar(5)) + '] int sparse' 
  set @count += 1
end
set @tab += ' ,col_values xml column_set for all_sparse_columns);'
select @tab
exec(@tab)
*/

drop table maxcols
go

declare @tab varchar(max)
set @tab = dbo.MakeSparseTab('maxcols', 29998) -- max is 29998
exec(@tab);
go

select count(*) from sys.columns where object_id = OBJECT_ID('maxcols')
go

-- select all of the columns
exec dbo.SelectAll 'maxcols', 'c', ''
go

delete maxcols
go

set nocount on
declare @nrows int = 0
declare @ins varchar(max)
while @nrows < 10000
begin
	set @ins = dbo.RandomInsert('maxcols', 30, 98);
	begin try
	exec(@ins)
	end try
	begin catch
	end catch
	set @nrows += 1
end

select COUNT(*) from maxcols
go

select * from maxcols
go

/* illustrate size of sparse vertor in table size
declare @tab varchar(max)
set @tab = dbo.SparseStringTab('maxcols', 29996) -- max is 29998
select LEN(@tab)
exec(@tab);

-- this puts it up to 8004 non-sparse
alter table maxcols add str1 char(8000)

-- this should be 8004 + sizeof sparse vector + this column
alter table maxcols add str2 char(100) -- fails
alter table maxcols add str2 char(45)  -- works 8004 + 45 = 8049

declare @tab varchar(max)
set @tab = dbo.InsertStrings('maxcols', 10) -- max is 29998
select LEN(@tab)
print @tab
exec(@tab);

-- Cannot create a row of size 8175 which is greater than the allowable maximum row size of 8060.
-- Changing the number after "replicate" doesn't change the message
insert maxcols (str1, col1,col2,col3,col4,col5,col6,col7,col8,col9,col10) 
       values(replicate('a',7800), 'string1','string2','string3','string4','string5','string6','string7','string8','string9','string10');

alter table maxcols alter column str1 char(7900)

-- Cannot create a row of size 8175 which is greater than the allowable maximum row size of 8060.
insert maxcols (str1, col1,col2,col3,col4,col5,col6,col7,col8,col9,col10) 
       values(replicate('a',7800), 'string1','string2','string3','string4','string5','string6','string7','string8','string9','string10');

alter table maxcols drop column str1
alter table maxcols drop column str2
alter table maxcols add str1 char(8000)
alter table maxcols add str2 char(45)


-- Cannot create a row of size 8068 which is greater than the allowable maximum row size of 8060.
insert maxcols (str1, str2, col1) 
       values(replicate('a',8000), replicate('a',45), '')
       
delete maxcols
       
alter table maxcols alter column str2 char(37)

-- Cannot create a row of size 8068 which is greater than the allowable maximum row size of 8060.
insert maxcols (str1, str2, col1) 
       values(replicate('a',8000), replicate('a',37), '')
       
alter table maxcols drop column str2

-- Cannot create a row of size 8068 which is greater than the allowable maximum row size of 8060.
insert maxcols (str1, col1) 
       values(replicate('a',8000), '')
*/
