
CREATE TABLE temp1 (
 id int identity,
 col1 int
)
go

-- can add columnset with alter when no sparse columns
ALTER TABLE temp1 ADD columnset XML COLUMN_SET FOR ALL_SPARSE_COLUMNS
go 

CREATE TABLE temp2 (
 id int identity,
 col1 int sparse null
)
go

-- cannot add columnset when there are existing sparse columns
-- because this changes the behavior of "SELECT * FROM"
ALTER TABLE temp2 ADD columnset XML COLUMN_SET FOR ALL_SPARSE_COLUMNS
go 

--
drop table maxcols 
go

declare @tab varchar(max)
set @tab = dbo.MakeSparseTab('maxcols', 10) -- max is 29998
exec(@tab);
go

select * from sys.columns where object_id = object_id('maxcols')
go

alter table maxcols drop column col_values
go

drop table maxcols 
go
declare @tab varchar(max)
set @tab = dbo.MakeSparseTab('maxcols', 1500) -- max is 29998
exec(@tab);
go

-- but not if the table contains more than 1024 columns
alter table maxcols drop column col_values
go