
-- uses the sparse table from hardware store
use testdb
go

select * from products

-- sorted by value
select col_values, 
       col_values.query('
       for $i in /*
       order by $i
       return $i') as sorted_by_value
from products

select col_values, 
       col_values.query('
       for $i in /*
       order by local-name($i)
       return $i') as sorted_by_name
from products

-- sorted in reverse
select col_values, 
       col_values.query('
       for $i in /*
       order by local-name($i) descending
       return $i') as sorted_by_name_descending
from products

-- beginning of product catalog
select id, name, col_values as [description] from products for xml raw('product'), root('products')

-- attribute statistics on each product 
select  MAX(col_values.value('count(/*)', 'int')) as max_attributes,
		MIN(col_values.value('count(/*)', 'int')) as min_attributes,
		AVG(col_values.value('count(/*)', 'int')) as avg_number_of_attributes
from products

select id, name, col_values, 
       col_values.value('count(/*)', 'int') as count_of_attributes
from products


-- columnset with "for xml"
SELECT * FROM dbo.products FOR XML AUTO
go


