/*============================================================================
  File:     mondial_latlong.sql

  Summary:  This script adds spatial geography columns to three tables in the 
			Mondial database. To define the Mondial database, reference the 
			"1-TSQL" directory. The tables are then populated with the 
			Latitude/Longitude data that already exists in Mondial.

  Date:     August 2008

  SQL Server Version: 10.0.1600.22 (RTM)
------------------------------------------------------------------------------
  Written by Bob Beauchemin, SQLskills.com

  For more scripts and sample code, check out http://www.SQLskills.com

  This script is intended only as a supplement to SQL Server Jumpstart program.
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/


use mondial
go

select Geography::Point(Latitude, Longitude, 4326) from city
 where Longitude is not null and Latitude is not null
 
 alter table city add geog Geography
 go
 
 update city set geog = Geography::Point(Latitude, Longitude, 4326) 
 where Longitude is not null and Latitude is not null
 go
 
 alter table island add geog Geography
 go
 
 update island set geog = Geography::Point(Latitude, Longitude, 4326) 
 where Longitude is not null and Latitude is not null
 go
 
alter table mountain add geog Geography
 go
 
 update mountain set geog = Geography::Point(Latitude, Longitude, 4326) 
 where Longitude is not null and Latitude is not null
 go