
use Mondial
go

-- 718 rows
select count(*) from city where geog is not null

CREATE SPATIAL INDEX city_spatial_idx
   ON city(geog)
   USING GEOGRAPHY_GRID
   WITH (GRIDS = (HIGH, HIGH, HIGH, HIGH),
    CELLS_PER_OBJECT = 64,
    PAD_INDEX  = ON );
go

select * from city
go

DECLARE @qs geography = (
select name from city
where geog.STIntersects((select geom from spatialsamples..admin00 where admin_name = 'Oregon')) = 1
)

DECLARE @x xml;
EXEC sp_help_spatial_geography_index_xml 'dbo.city', 'city_spatial_idx', 4, @qs, @x output;
SELECT @x
SELECT @x.value('(/Primary_Filter_Efficiency/text())[1]', 'float');
go

/*
<Total_Number_Of_ObjectCells_In_Level0_For_QuerySample>1</Total_Number_Of_ObjectCells_In_Level0_For_QuerySample>
<Total_Number_Of_ObjectCells_In_Level0_In_Index>2333</Total_Number_Of_ObjectCells_In_Level0_In_Index>
<Total_Number_Of_ObjectCells_In_Level4_In_Index>726</Total_Number_Of_ObjectCells_In_Level4_In_Index>
<Total_Number_Of_Intersecting_ObjectCells_In_Level4_In_Index>720</Total_Number_Of_Intersecting_ObjectCells_In_Level4_In_Index>
<Total_Number_Of_Border_ObjectCells_In_Level0_For_QuerySample>1</Total_Number_Of_Border_ObjectCells_In_Level0_For_QuerySample>
<Total_Number_Of_Border_ObjectCells_In_Level0_In_Index>2333</Total_Number_Of_Border_ObjectCells_In_Level0_In_Index>
<Total_Number_Of_Border_ObjectCells_In_Level4_In_Index>6</Total_Number_Of_Border_ObjectCells_In_Level4_In_Index>
<Number_Of_Rows_Selected_By_Primary_Filter>2309</Number_Of_Rows_Selected_By_Primary_Filter>
<Number_Of_Rows_Selected_By_Internal_Filter>0</Number_Of_Rows_Selected_By_Internal_Filter>
<Number_Of_Times_Secondary_Filter_Is_Called>2309</Number_Of_Times_Secondary_Filter_Is_Called>
<Number_Of_Rows_Output>0</Number_Of_Rows_Output>
<Percentage_Of_Rows_NotSelected_By_Primary_Filter>2.431989511635529e+001</Percentage_Of_Rows_NotSelected_By_Primary_Filter>
<Percentage_Of_Primary_Filter_Rows_Selected_By_Internal_Filter>0.000000000000000e+000</Percentage_Of_Primary_Filter_Rows_Selected_By_Internal_Filter>
<Internal_Filter_Efficiency>0.0</Internal_Filter_Efficiency>
<Primary_Filter_Efficiency>0.000000000000000e+000</Primary_Filter_Efficiency>

<Base_Table_Rows>3051</Base_Table_Rows>
<Bounding_Box_xmin>-1.800000000000000e+002</Bounding_Box_xmin>
<Bounding_Box_ymin>-9.000000000000000e+001</Bounding_Box_ymin>
<Bounding_Box_xmax>1.800000000000000e+002</Bounding_Box_xmax>
<Bounding_Box_ymax>9.000000000000000e+001</Bounding_Box_ymax>
<Grid_Size_Level_1>256</Grid_Size_Level_1>
<Grid_Size_Level_2>256</Grid_Size_Level_2>
<Grid_Size_Level_3>256</Grid_Size_Level_3>
<Grid_Size_Level_4>256</Grid_Size_Level_4>
<Cells_Per_Object>64</Cells_Per_Object>
<Total_Primary_Index_Rows>3059</Total_Primary_Index_Rows>
<Total_Primary_Index_Pages>21</Total_Primary_Index_Pages>
<Average_Number_Of_Index_Rows_Per_Base_Row>1</Average_Number_Of_Index_Rows_Per_Base_Row>
<Total_Number_Of_ObjectCells_In_Level0_For_QuerySample>1</Total_Number_Of_ObjectCells_In_Level0_For_QuerySample>
<Total_Number_Of_ObjectCells_In_Level0_In_Index>2333</Total_Number_Of_ObjectCells_In_Level0_In_Index>
<Total_Number_Of_ObjectCells_In_Level4_In_Index>726</Total_Number_Of_ObjectCells_In_Level4_In_Index>
<Total_Number_Of_Intersecting_ObjectCells_In_Level4_In_Index>720</Total_Number_Of_Intersecting_ObjectCells_In_Level4_In_Index>
<Total_Number_Of_Border_ObjectCells_In_Level0_For_QuerySample>1</Total_Number_Of_Border_ObjectCells_In_Level0_For_QuerySample>
<Total_Number_Of_Border_ObjectCells_In_Level0_In_Index>2333</Total_Number_Of_Border_ObjectCells_In_Level0_In_Index>
<Total_Number_Of_Border_ObjectCells_In_Level4_In_Index>6</Total_Number_Of_Border_ObjectCells_In_Level4_In_Index>
<Interior_To_Total_Cells_Normalized_To_Leaf_Grid_Percentage>0.0</Interior_To_Total_Cells_Normalized_To_Leaf_Grid_Percentage>
<Intersecting_To_Total_Cells_Normalized_To_Leaf_Grid_Percentage>0.0</Intersecting_To_Total_Cells_Normalized_To_Leaf_Grid_Percentage>
<Border_To_Total_Cells_Normalized_To_Leaf_Grid_Percentage>0.0</Border_To_Total_Cells_Normalized_To_Leaf_Grid_Percentage>
<Average_Cells_Per_Object_Normalized_To_Leaf_Grid>0.0</Average_Cells_Per_Object_Normalized_To_Leaf_Grid>
<Average_Objects_PerLeaf_GridCell>0.0</Average_Objects_PerLeaf_GridCell>
<Number_Of_SRIDs_Found>2</Number_Of_SRIDs_Found>
<Width_Of_Cell_In_Level1>1.406250000000000e+000</Width_Of_Cell_In_Level1>
<Width_Of_Cell_In_Level2>5.493164062500000e-003</Width_Of_Cell_In_Level2>
<Width_Of_Cell_In_Level3>2.145767211914063e-005</Width_Of_Cell_In_Level3>
<Width_Of_Cell_In_Level4>8.381903171539307e-008</Width_Of_Cell_In_Level4>
<Height_Of_Cell_In_Level1>7.031250000000000e-001</Height_Of_Cell_In_Level1>
<Height_Of_Cell_In_Level2>2.746582031250000e-003</Height_Of_Cell_In_Level2>
<Height_Of_Cell_In_Level3>1.072883605957031e-005</Height_Of_Cell_In_Level3>
<Height_Of_Cell_In_Level4>4.190951585769653e-008</Height_Of_Cell_In_Level4>
<Area_Of_Cell_In_Level1>2.531250000000000e+002</Area_Of_Cell_In_Level1>
<Area_Of_Cell_In_Level2>9.887695312500000e-001</Area_Of_Cell_In_Level2>
<Area_Of_Cell_In_Level3>3.862380981445313e-003</Area_Of_Cell_In_Level3>
<Area_Of_Cell_In_Level4>1.508742570877075e-005</Area_Of_Cell_In_Level4>
<CellArea_To_BoundingBoxArea_Percentage_In_Level1>3.906250000000000e-001</CellArea_To_BoundingBoxArea_Percentage_In_Level1>
<CellArea_To_BoundingBoxArea_Percentage_In_Level2>1.525878906250000e-003</CellArea_To_BoundingBoxArea_Percentage_In_Level2>
<CellArea_To_BoundingBoxArea_Percentage_In_Level3>5.960464477539063e-006</CellArea_To_BoundingBoxArea_Percentage_In_Level3>
<CellArea_To_BoundingBoxArea_Percentage_In_Level4>2.328306436538696e-008</CellArea_To_BoundingBoxArea_Percentage_In_Level4>
<Number_Of_Rows_Selected_By_Primary_Filter>2309</Number_Of_Rows_Selected_By_Primary_Filter>
<Number_Of_Rows_Selected_By_Internal_Filter>0</Number_Of_Rows_Selected_By_Internal_Filter>
<Number_Of_Times_Secondary_Filter_Is_Called>2309</Number_Of_Times_Secondary_Filter_Is_Called>
<Number_Of_Rows_Output>0</Number_Of_Rows_Output>
<Percentage_Of_Rows_NotSelected_By_Primary_Filter>2.431989511635529e+001</Percentage_Of_Rows_NotSelected_By_Primary_Filter>
<Percentage_Of_Primary_Filter_Rows_Selected_By_Internal_Filter>0.000000000000000e+000</Percentage_Of_Primary_Filter_Rows_Selected_By_Internal_Filter>
<Internal_Filter_Efficiency>0.0</Internal_Filter_Efficiency>
<Primary_Filter_Efficiency>0.000000000000000e+000</Primary_Filter_Efficiency>

*/