
-- Which roads intersect the Microsoft Campus?
-- Use SQL Server sptial generator from Virtual Earth to get "Microsoft Campus"
-- http://mikeo.co.uk/demo/sqlspatial/default.aspx

use Sample_USA
go

select top 100 * from Highways 

DECLARE @Campus geography = 
  geography::STGeomFromText('POLYGON((-122.14015960693361 47.64697370526774, -122.14015960693361 47.64697370526774, -122.14153289794925 47.636969220376734, -122.14153289794925 47.636969220376734, -122.1227788925171 47.63725839422541, -122.1227788925171 47.63725839422541, -122.12410926818849 47.6457883027862, -122.12410926818849 47.6457883027862, -122.14015960693361 47.64697370526774))', 4326)

select id, signt, signn
from Highways h
where h.GEOG.STIntersects(@Campus) = 1

select h.id, signt, signn
from Highways h
join census.dbo.states s on h.STFIPS = s.fip
where h.GEOG.STIntersects(@Campus) = 1


-- Does my land claim overlap yours
-- Which zipcodes are part of my congressional district? 

use Sample_USA
go

-- state # 41 is Oregon, #53 is Washington
select * from states

use census
go

-- check state number
select * from congress where state = 41 -- Oregon, id 116 is my district

select * from zipcodes
go

with mydistrict as
(
  select shapegeog from congress where id = 116
)
select * from mydistrict
join zipcodes z
on mydistrict.shapegeog.STIntersects(z.shapegeog)=1
where z.state = 41

-- List the Italian Restaurants with 5 km
-- All the restaurants within 5 km

use geonames
go

select top 100 * from geonames where fcode = 'REST'

declare @me geography = 'POINT(-78.89 42.65)'

select top 100 * from geonames 
where GEOG.STDistance(@me) < 5000
and fcode = 'REST'
